/* Copyright (C) 2010 MoSync AB

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License, version 2, as published by
the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with this program; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.
*/

#ifndef GOOGLECELLIDDATABASE_H_
#define GOOGLECELLIDDATABASE_H_
#include "CellIDDatabase.h"
#include <MAUtil/Connection.h>

using namespace MAUtil;

//This provides access to a _hidden_ Google API.  Google may change the specification or availability of this
//API at any time.

class GoogleCellIDDatabase : public CellIDDatabase,
							 public HttpConnectionListener
{
	public:
		GoogleCellIDDatabase();
		~GoogleCellIDDatabase();

		//CellIDDatabase interface
		MALocation& convertToLocation(MACellInfo* cellinfo);

		//HttpConnectionListener interface
		void httpFinished(HttpConnection* http, int result);
		void connectFinished(Connection* conn, int result);
		void connRecvFinished(Connection* conn, int result);
		void connWriteFinished(Connection* conn, int result);
		void connReadFinished(Connection* conn, int result);

	private:
		HttpConnection mConnection;
		MALocation mLocation;

		MAHandle mData;
		int mRecLength;
		byte pd[55];

		void getPostData(byte* output, int MCC, int MNC, int LAC, int CID, bool shortCID = false);
};

#endif /* GOOGLECELLIDDATABASE_H_ */
