/*
 * LocationBus.h
 *
 *  Created on: 14 May 2010
 *      Author: sjp
 */

#ifndef LOCATIONBUS_H_
#define LOCATIONBUS_H_

#include "../Location.h"
#include <MAUtil/Set.h>

using namespace MAUtil;

//When a location is received, regardless of the source, it is passed to the LocationBus.
//ILocationListeners can subscribe to the bus to be informed when a location is received.

class LocationBus : public ILocationBus
{
  public:
    LocationBus();
    ~LocationBus();

    void addLocationListener(ILocationListener* l);
    void removeLocationListener(ILocationListener* l);

    void receiveLocation(MALocation& location);

    void informListeners(MALocation& location);

  private:
    Set<ILocationListener*> mListeners;

    static LocationBus* mLocationBus;

    double mLat;
    double mLon;
    double mAccuracy;

    double toRad(double input);
};

#endif /* LOCATIONBUS_H_ */
