#ifndef CELLIDPROVIDER_H_
#define CELLIDPROVIDER_H_

#include "../Location.h"
#include <MAUtil/Environment.h>
#include "../CellIDDatabases/CellIDDatabase.h"

#include <IX_CELLID.h>

//This is intended as a base class for different CellID Implementations to share
using namespace MAUtil;

class CellIDProvider : public ILocationProvider,
					   protected TimerListener
{
	public:
        CellIDProvider();
        ~CellIDProvider();

        //ILocationProvider Interface
		bool startLocation();
		void stopLocation();

		//TimerListener Interface
		void runTimerEvent();

		//This is the method which each provider should implement
		virtual int getCellInfo(MACellInfo* cellinfo) = 0;

		//Set the database which is going to be used to convert the cellid
		//to a latitude/longitude
		void setCellIDDatabase(CellIDDatabase* ciddb);

	private:
        MACellInfo* cellinfo;
        bool mTiming;
        int mCellId;

        CellIDDatabase* mDatabase;

        bool getLocation();
};


#endif /* CELLIDPROVIDER_H_ */
