/*
 * FallbackCellIDProvider.cpp
 *
 *  Created on: 1 Jul 2010
 *      Author: orac7
 */

#include "FallbackCellIDProvider.h"
#include "../std.h"
#include "../Utilities/Convert.h"
#include <mastdlib.h>
#include <mavsprintf.h>

int FallbackCellIDProvider::getCellInfo(MACellInfo* cellinfo)
{
	LOG("Getting fallback Cell Info");
	int ret;
	bool success = false;

	char buffer[12];
	char* bptr = buffer;

	//Get the CellID
	if(maGetSystemProperty("phone.cellid", bptr, 12) > 0)
	{
		LOG("Got a cellid '%s'", bptr);
		cellinfo->cellId = Convert::hexToInt(bptr);
		memset(bptr, 0, 12);

		success = true;
	}

	if(success && maGetSystemProperty("phone.lac", bptr, 12) > 0)
	{
		LOG("Got a lac '%s'", bptr);
		cellinfo->lac = Convert::toInt(buffer);

		memset(bptr, 0, 12);
	}
	else
		success = false;

	if(success && maGetSystemProperty("phone.mcc", bptr, 4) > 0)
	{
		LOG("Got a mcc '%s'", bptr);
		//Convert the value from decimal to hex
		char temp[4];
		sprintf(temp, "%3x", Convert::toInt(buffer));
		strcpy(cellinfo->mcc, temp);
		memset(bptr, 0, 12);
	}
	else
		success = false;

	if(success && maGetSystemProperty("phone.mnc", bptr, 8) > 0)
	{
		LOG("Got a mnc '%s'", bptr);
		//Convert the value from decimal to hex
		char temp[8];
		sprintf(temp, "%7x", Convert::toInt(buffer));
		strcpy(cellinfo->mnc, temp);
		memset(bptr, 0, 12);
	}
	else
		success = false;

	if(success)
	{
		LOG("Success!");
		LOG("CellID: %8x", cellinfo->cellId);
		return 1;
	}
	else
	{
		LOG("Failure");
		return -1;
	}
}
