/* Copyright (C) 2010 MoSync AB

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License, version 2, as published by
the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with this program; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.
*/
#include "TestProvider.h"
#include "../LocationBus/LocationBus.h"
#include "../std.h"

TestProvider::TestProvider()
{
  active = false;

  //Default locations

  //Welford Road Ground, Leicester
  //mLatitude = 52.62419;
  //mLongitude = -1.13277;

  //Greenwich Park, London
  //mLatitude = 51.49663;
  //mLongitude = 0.00;

  //The island of Krk, Croatia
  //mLatitude = 45.1176;
  //mLongitude = 14.5267;

  //Wankhede Cricket Ground, Mumbai,
  //mLatitude = 18.93907;
  //mLongitude = 72.82618;

  //Raffles Hotel, Singapore
  //mLatitude = 1.295086;
  //mLongitude = 103.854656;

  //Sydney Opera House, Sydney
  mLatitude = -33.85661;
  mLongitude = 151.21502;

  //Table Bay Harbour, Cape Town, South Africa
  //mLatitude = -33.91623;
  //mLongitude = 18.42845;

  //Pucon, Chile
  //mLatitude = -39.27545;
  //mLongitude = -71.96811;

  //Drottingholm Palace, Stockholm, Sweden
  //mLatitude = 59.32162;
  //mLongitude = 17.88752;

  //Whitehouse, Washington, USA
  //mLatitude = 38.8975;
  //mLongitude = -77.0366;

}

TestProvider::~TestProvider()
{
  if(active)
    stopLocation();
}

bool TestProvider::startLocation()
{
  if(active)
      return true;

  //Register for an event every 5 seconds to send the next location
  Environment::getEnvironment().addTimer(this, 5000, 0);
  active = true;

  return active;
}

void TestProvider::stopLocation()
{
  if(active)
    Environment::getEnvironment().removeTimer(this);

  active = false;
}

void TestProvider::runTimerEvent()
{
  raiseLocation();
}

void TestProvider::setLatLon(double lat, double lon)
{
  mLatitude = lat;
  mLongitude = lon;
}

void TestProvider::raiseLocation()
{
  MALocation loc;
  loc.alt = 0;
  loc.horzAcc = 50;
  loc.lat = mLatitude;
  loc.lon = mLongitude;
  loc.state = 0;
  loc.vertAcc = 10;

  APPCONTROLLER->getLocationBus()->receiveLocation(loc);
}
