/* Copyright (C) 2010 MoSync AB

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License, version 2, as published by
the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with this program; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.
*/

#ifndef TESTPROVIDER_H_
#define TESTPROVIDER_H_

#include "../Location.h"
#include <MAUtil/Environment.h>

using namespace MAUtil;

//The test provider is useful for testing your application in the MoRE emulator.
//It returns a test location (you can set the lat/lon if you want to, and it pushes
//locations to the bus every 5 seconds.
class TestProvider : public ILocationProvider,
                    protected TimerListener
{
    public:
        TestProvider();
        ~TestProvider();
        bool startLocation();
        void stopLocation();
        void runTimerEvent();

        void setLatLon(double lat, double lon);
    private:
        bool active;

        double mLatitude;
        double mLongitude;

        void raiseLocation();
};


#endif /* TESTPROVIDER_H_ */
