/* Copyright (C) 2010 MoSync AB

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License, version 2, as published by
the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with this program; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.
*/

#include "HeapLogger.h"
#include <conprint.h>

namespace Log4MoSync
{
	HeapLogger::HeapLogger()
	{
		_nextLog = 0;
	}

	HeapLogger::~HeapLogger()
	{}

	void HeapLogger::addLog(String& message, LoggingLevel level)
	{
        if(message.length() > 200)
          message = message.substr(0, 200);

		_logs.add(new LogEntry(message, level));
		tm* splitTime = new tm();
		split_time(maLocalTime(), splitTime);
		lprintfln("%02d/%02d/%04d - %02d:%02d:%02d - %s",
				splitTime->tm_mday,
				splitTime->tm_mon + 1,
				splitTime->tm_year + 1900,
				splitTime->tm_hour,
				splitTime->tm_min,
				splitTime->tm_sec,
				message.c_str());
	}

	void HeapLogger::addLog(const char* message, ...)
	{
		char buffer[255];
		va_list args;
		va_start(args, message);
		vsprintf(buffer, message, args);
		va_end(args);
		String logMessage = buffer;
		addLog(logMessage);
	}

	void HeapLogger::moveFirst()
	{
		_nextLog = 0;
	}

	LogEntry* HeapLogger::getNextLog()
	{
		LogEntry* templog = NULL;
		if(_nextLog < _logs.size())
			templog = _logs[_nextLog++];

		return templog;
	}
}
