/* Copyright (C) 2010 MoSync AB

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License, version 2, as published by
the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with this program; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.
*/

#ifndef HTTPLOGGER_H_
#define HTTPLOGGER_H_
#include "ILogger.h"
#include "Levels.h"
#include "LogEntry.h"
#include <MAUtil/Vector.h>
#include <MAUtil/String.h>
#include "matime.h"

using namespace MAUtil;

namespace Log4MoSync
{
    class HttpLogger : public ILogger
    {
        public:
            HttpLogger();
            ~HttpLogger();

            void addLog(String& message, LoggingLevel level = Log4MoSync::TRACE);
            void addLog(const char* message, ...);
            void moveFirst();
            LogEntry* getNextLog();

            void setWriteURL(const char* writeUrl);
            void setReadURL(const char* readUrl);

        private:
            Vector<LogEntry*> _logs;
            int _nextLog;
    };
};


#endif /* HTTPLOGGER_H_ */
