/* Copyright (C) 2010 MoSync AB

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License, version 2, as published by
the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with this program; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.
*/

#ifndef LOGENTRY_H_
#define LOGENTRY_H_

#include "Levels.h"
#include "maapi.h"
#include <MAUtil/String.h>
#include "matime.h"

using namespace MAUtil;

namespace Log4MoSync
{
	class LogEntry
	{
		public:
			LogEntry(String& message, LoggingLevel level = Log4MoSync::TRACE);
			~LogEntry();

			String& getMessage();
			time_t getTime();
			LoggingLevel getLevel();

		private:
			String _message;
			time_t _time;
			LoggingLevel _level;
	};
};

#endif /* //LOGENTRY_H_ */
