/* Copyright (C) 2010 MoSync AB

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License, version 2, as published by
the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with this program; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.
*/

#ifndef REVERSEGEOCODE_H_
#define REVERSEGEOCODE_H_

#include <MAUtil/String.h>

using namespace MAUtil;

class ReverseGeocodeListener
{
	public:
		virtual void locationNameResolved(String& locationName) = 0;
};

//Connects to a Reverse Geocode service
class ReverseGeocode
{
	public:
		virtual void addReverseGeocodeListener(ReverseGeocodeListener* listener);
		virtual void removeReverseGeocodeListener(ReverseGeocodeListener* listener);

		//Perform the reverse geocode
		virtual void performReverseGeocode(double latitude, double longitude, bool isExact = true) = 0;
};

#endif /* REVERSEGEOCODE_H_ */
