/* Copyright (C) 2010 MoSync AB

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License, version 2, as published by
the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with this program; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.
*/
#ifndef GUID_H_
#define GUID_H_

#include <MAUtil/String.h>
#include <maapi.h>
using namespace MAUtil;

//A quick'n'hacky version of UUID Version 4 (all random data)
class Guid
{
  public:
    Guid();
    Guid(String gstr);
    Guid(int seed);

    String& toString();
    void fromString(String string);

    bool operator ==(Guid* g);
    bool operator !=(Guid* g);
    bool operator ==(Guid g);
    bool operator !=(Guid g);

    static Guid* newGuid();

  private:
    String mStr;
    uint mSectionA;
    ushort mSectionB;
    ushort mSectionC;
    ushort mSectionD;
    ushort mSectionEhi;
    ushort mSectionEmi;
    ushort mSectionElo;
};
#endif /* GUID_H_ */
